GNU Radio C++ API Reference: FrequencyDisplayPlot Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
FrequencyDisplayPlot Class Reference
GNU Radio C++ Signal Processing Blocks » QT Graphical Interfaces

QWidget for displaying frequency domain (PSD) plots. More...

`#include <gnuradio/qtgui/FrequencyDisplayPlot.h>`

## Public Slots
void | setMaxFFTVisible (const bool)
void | setMinFFTVisible (const bool)
void | setMinFFTColor (QColor c)
void | setMaxFFTColor (QColor c)
void | setMarkerLowerIntensityColor (QColor c)
void | setMarkerLowerIntensityVisible (bool visible)
void | setMarkerUpperIntensityColor (QColor c)
void | setMarkerUpperIntensityVisible (bool visible)
void | setMarkerPeakAmplitudeColor (QColor c)
void | setMarkerNoiseFloorAmplitudeVisible (bool visible)
void | setMarkerNoiseFloorAmplitudeColor (QColor c)
void | setMarkerCFColor (QColor c)
void | setLowerIntensityLevel (const double)
void | setUpperIntensityLevel (const double)
void | onPickerPointSelected (const QPointF &p)
void | setAutoScale (bool state)
void | setAutoScaleShot ()
void | setPlotPosHalf (bool half)
void | setYLabel (const std::string &label, const std::string &unit)
void | clearMaxData ()
void | clearMinData ()
void | attachTriggerLine (bool en)
void | setTriggerLine (double value)
Public Slots inherited from DisplayPlot
virtual void | disableLegend ()
virtual void | setAxisLabels (bool en)
virtual void | setXaxis (double min, double max)
virtual void | setLineLabel (unsigned int which, QString label)
virtual QString | getLineLabel (unsigned int which)
virtual void | setLineColor (unsigned int which, QColor color)
virtual QColor | getLineColor (unsigned int which) const
virtual void | setLineWidth (unsigned int which, int width)
virtual int | getLineWidth (unsigned int which) const
virtual void | setLineStyle (unsigned int which, Qt::PenStyle style)
virtual Qt::PenStyle | getLineStyle (unsigned int which) const
virtual void | setLineMarker (unsigned int which, QwtSymbol::Style marker)
virtual QwtSymbol::Style | getLineMarker (unsigned int which) const
virtual void | setMarkerAlpha (unsigned int which, int alpha)
virtual int | getMarkerAlpha (unsigned int which) const
void | setLineColor1 (QColor)
void | setLineColor2 (QColor)
void | setLineColor3 (QColor)
void | setLineColor4 (QColor)
void | setLineColor5 (QColor)
void | setLineColor6 (QColor)
void | setLineColor7 (QColor)
void | setLineColor8 (QColor)
void | setLineColor9 (QColor)
void | setLineWidth1 (int)
void | setLineWidth2 (int)
void | setLineWidth3 (int)
void | setLineWidth4 (int)
void | setLineWidth5 (int)
void | setLineWidth6 (int)
void | setLineWidth7 (int)
void | setLineWidth8 (int)
void | setLineWidth9 (int)
void | setLineStyle1 (Qt::PenStyle)
void | setLineStyle2 (Qt::PenStyle)
void | setLineStyle3 (Qt::PenStyle)
void | setLineStyle4 (Qt::PenStyle)
void | setLineStyle5 (Qt::PenStyle)
void | setLineStyle6 (Qt::PenStyle)
void | setLineStyle7 (Qt::PenStyle)
void | setLineStyle8 (Qt::PenStyle)
void | setLineStyle9 (Qt::PenStyle)
void | setLineMarker1 (QwtSymbol::Style)
void | setLineMarker2 (QwtSymbol::Style)
void | setLineMarker3 (QwtSymbol::Style)
void | setLineMarker4 (QwtSymbol::Style)
void | setLineMarker5 (QwtSymbol::Style)
void | setLineMarker6 (QwtSymbol::Style)
void | setLineMarker7 (QwtSymbol::Style)
void | setLineMarker8 (QwtSymbol::Style)
void | setLineMarker9 (QwtSymbol::Style)
void | setMarkerAlpha1 (int)
void | setMarkerAlpha2 (int)
void | setMarkerAlpha3 (int)
void | setMarkerAlpha4 (int)
void | setMarkerAlpha5 (int)
void | setMarkerAlpha6 (int)
void | setMarkerAlpha7 (int)
void | setMarkerAlpha8 (int)
void | setMarkerAlpha9 (int)
void | setZoomerColor (QColor c)
void | setPaletteColor (QColor c)
void | setAxisLabelFontSize (int axisId, int fs)
void | setYaxisLabelFontSize (int fs)
void | setXaxisLabelFontSize (int fs)
void | setAxesLabelFontSize (int fs)
void | setStop (bool on)
void | resizeSlot (QSize *s)
void | onPickerPointSelected (const QPointF &p)

## Public Member Functions
| FrequencyDisplayPlot (int nplots, QWidget *)
| ~FrequencyDisplayPlot () override
void | setFrequencyRange (const double, const double, const double units=1000.0, const std::string &strunits="kHz")
double | getStartFrequency () const
double | getStopFrequency () const
void | plotNewData (const std::vector< const double * > dataPoints, const int64_t numDataPoints, const double noiseFloorAmplitude, const double peakFrequency, const double peakAmplitude, const double timeInterval)
void | plotNewData (const double *dataPoints, const int64_t numDataPoints, const double noiseFloorAmplitude, const double peakFrequency, const double peakAmplitude, const double timeInterval)
void | replot () override
void | setYaxis (double min, double max) override
double | getYMin () const
double | getYMax () const
void | setTraceColour (QColor)
void | setBGColour (QColor c)
void | showCFMarker (const bool)
bool | getMaxFFTVisible () const
bool | getMinFFTVisible () const
const QColor | getMinFFTColor () const
const QColor | getMaxFFTColor () const
const QColor | getMarkerLowerIntensityColor () const
bool | getMarkerLowerIntensityVisible () const
const QColor | getMarkerUpperIntensityColor () const
bool | getMarkerUpperIntensityVisible () const
const QColor | getMarkerPeakAmplitudeColor () const
bool | getMarkerNoiseFloorAmplitudeVisible () const
const QColor | getMarkerNoiseFloorAmplitudeColor () const
const QColor | getMarkerCFColor () const
Public Member Functions inherited from DisplayPlot
| DisplayPlot (int nplots, QWidget *)
| ~DisplayPlot () override
const QColor | getLineColor1 () const
const QColor | getLineColor2 () const
const QColor | getLineColor3 () const
const QColor | getLineColor4 () const
const QColor | getLineColor5 () const
const QColor | getLineColor6 () const
const QColor | getLineColor7 () const
const QColor | getLineColor8 () const
const QColor | getLineColor9 () const
int | getLineWidth1 () const
int | getLineWidth2 () const
int | getLineWidth3 () const
int | getLineWidth4 () const
int | getLineWidth5 () const
int | getLineWidth6 () const
int | getLineWidth7 () const
int | getLineWidth8 () const
int | getLineWidth9 () const
Qt::PenStyle | getLineStyle1 () const
Qt::PenStyle | getLineStyle2 () const
Qt::PenStyle | getLineStyle3 () const
Qt::PenStyle | getLineStyle4 () const
Qt::PenStyle | getLineStyle5 () const
Qt::PenStyle | getLineStyle6 () const
Qt::PenStyle | getLineStyle7 () const
Qt::PenStyle | getLineStyle8 () const
Qt::PenStyle | getLineStyle9 () const
QwtSymbol::Style | getLineMarker1 () const
QwtSymbol::Style | getLineMarker2 () const
QwtSymbol::Style | getLineMarker3 () const
QwtSymbol::Style | getLineMarker4 () const
QwtSymbol::Style | getLineMarker5 () const
QwtSymbol::Style | getLineMarker6 () const
QwtSymbol::Style | getLineMarker7 () const
QwtSymbol::Style | getLineMarker8 () const
QwtSymbol::Style | getLineMarker9 () const
int | getMarkerAlpha1 () const
int | getMarkerAlpha2 () const
int | getMarkerAlpha3 () const
int | getMarkerAlpha4 () const
int | getMarkerAlpha5 () const
int | getMarkerAlpha6 () const
int | getMarkerAlpha7 () const
int | getMarkerAlpha8 () const
int | getMarkerAlpha9 () const
QColor | getZoomerColor () const
QColor | getPaletteColor () const
int | getAxisLabelFontSize (int axisId) const
int | getYaxisLabelFontSize () const
int | getXaxisLabelFontSize () const
int | getAxesLabelFontSize () const

## Properties
QColor | min_fft_color
QColor | max_fft_color
bool | min_fft_visible
bool | max_fft_visible
QColor | marker_lower_intensity_color
bool | marker_lower_intensity_visible
QColor | marker_upper_intensity_color
bool | marker_upper_intensity_visible
QColor | marker_peak_amplitude_color
QColor | marker_noise_floor_amplitude_color
bool | marker_noise_floor_amplitude_visible
QColor | marker_CF_color
Properties inherited from DisplayPlot
QColor | line_color1
QColor | line_color2
QColor | line_color3
QColor | line_color4
QColor | line_color5
QColor | line_color6
QColor | line_color7
QColor | line_color8
QColor | line_color9
int | line_width1
int | line_width2
int | line_width3
int | line_width4
int | line_width5
int | line_width6
int | line_width7
int | line_width8
int | line_width9
Qt::PenStyle | line_style1
Qt::PenStyle | line_style2
Qt::PenStyle | line_style3
Qt::PenStyle | line_style4
Qt::PenStyle | line_style5
Qt::PenStyle | line_style6
Qt::PenStyle | line_style7
Qt::PenStyle | line_style8
Qt::PenStyle | line_style9
QwtSymbolStyle | line_marker1
QwtSymbolStyle | line_marker2
QwtSymbolStyle | line_marker3
QwtSymbolStyle | line_marker4
QwtSymbolStyle | line_marker5
QwtSymbolStyle | line_marker6
QwtSymbolStyle | line_marker7
QwtSymbolStyle | line_marker8
QwtSymbolStyle | line_marker9
int | marker_alpha1
int | marker_alpha2
int | marker_alpha3
int | marker_alpha4
int | marker_alpha5
int | marker_alpha6
int | marker_alpha7
int | marker_alpha8
int | marker_alpha9
QColor | zoomer_color
QColor | palette_color
int | yaxis_label_font_size
int | xaxis_label_font_size
int | axes_label_font_size

## Additional Inherited Members
Signals inherited from DisplayPlot
void | plotPointSelected (const QPointF p)
Protected Slots inherited from DisplayPlot
virtual void | legendEntryChecked (QwtPlotItem *plotItem, bool on)
virtual void | legendEntryChecked (const QVariant &plotItem, bool on, int index)
Protected Attributes inherited from DisplayPlot
unsigned int | d_nplots
std::vector< QwtPlotCurve * > | d_plot_curve
QwtPlotPanner * | d_panner
QwtPlotZoomer * | d_zoomer
QwtDblClickPlotPicker * | d_picker
QwtPlotMagnifier * | d_magnifier
int64_t | d_numPoints
bool | d_stop
QList< QColor > | d_trace_colors
bool | d_autoscale_state

## Detailed Description

QWidget for displaying frequency domain (PSD) plots.

## Constructor & Destructor Documentation

## ◆ FrequencyDisplayPlot()

FrequencyDisplayPlot::FrequencyDisplayPlot | ( | int | nplots,
|  | QWidget * | )

Referenced by getStopFrequency(), and plotNewData().

## ◆ ~FrequencyDisplayPlot()

FrequencyDisplayPlot::~FrequencyDisplayPlot | ( |  | ) |
| override

References getMarkerNoiseFloorAmplitudeColor(), marker_noise_floor_amplitude_color, and setMarkerNoiseFloorAmplitudeColor().

## Member Function Documentation

## ◆ attachTriggerLine

void FrequencyDisplayPlot::attachTriggerLine | ( | bool | en | ) |
| slot

References setAutoScaleShot().

Referenced by setTriggerLine().

## ◆ clearMaxData

void FrequencyDisplayPlot::clearMaxData | ( |  | ) |
| slot

References onPickerPointSelected().

Referenced by setTriggerLine().

## ◆ clearMinData

void FrequencyDisplayPlot::clearMinData | ( |  | ) |
| slot

References setAutoScale().

Referenced by setTriggerLine().

## ◆ getMarkerCFColor()

const QColor FrequencyDisplayPlot::getMarkerCFColor | ( |  | ) | const

References getMarkerLowerIntensityColor(), getMaxFFTColor(), and getMinFFTColor().

Referenced by setFrequencyRange(), and setMarkerUpperIntensityColor().

## ◆ getMarkerLowerIntensityColor()

const QColor FrequencyDisplayPlot::getMarkerLowerIntensityColor | ( |  | ) | const

Referenced by getMarkerCFColor().

## ◆ getMarkerLowerIntensityVisible()

bool FrequencyDisplayPlot::getMarkerLowerIntensityVisible | ( |  | ) | const

References setTraceColour().

Referenced by setMaxFFTVisible().

## ◆ getMarkerNoiseFloorAmplitudeColor()

const QColor FrequencyDisplayPlot::getMarkerNoiseFloorAmplitudeColor | ( |  | ) | const

References getMinFFTVisible().

Referenced by setMarkerLowerIntensityVisible(), and ~FrequencyDisplayPlot().

## ◆ getMarkerNoiseFloorAmplitudeVisible()

bool FrequencyDisplayPlot::getMarkerNoiseFloorAmplitudeVisible | ( |  | ) | const

References getMaxFFTVisible().

Referenced by setFrequencyRange(), and setMarkerLowerIntensityColor().

## ◆ getMarkerPeakAmplitudeColor()

const QColor FrequencyDisplayPlot::getMarkerPeakAmplitudeColor | ( |  | ) | const

Referenced by setMaxFFTColor().

## ◆ getMarkerUpperIntensityColor()

const QColor FrequencyDisplayPlot::getMarkerUpperIntensityColor | ( |  | ) | const

References setBGColour().

Referenced by setMinFFTVisible().

## ◆ getMarkerUpperIntensityVisible()

bool FrequencyDisplayPlot::getMarkerUpperIntensityVisible | ( |  | ) | const

References showCFMarker().

Referenced by setMinFFTColor().

## ◆ getMaxFFTColor()

const QColor FrequencyDisplayPlot::getMaxFFTColor | ( |  | ) | const

References getYMax().

Referenced by getMarkerCFColor().

## ◆ getMaxFFTVisible()

bool FrequencyDisplayPlot::getMaxFFTVisible | ( |  | ) | const

Referenced by getMarkerNoiseFloorAmplitudeVisible().

## ◆ getMinFFTColor()

const QColor FrequencyDisplayPlot::getMinFFTColor | ( |  | ) | const

References getYMin().

Referenced by getMarkerCFColor().

## ◆ getMinFFTVisible()

bool FrequencyDisplayPlot::getMinFFTVisible | ( |  | ) | const

References setYaxis().

Referenced by getMarkerNoiseFloorAmplitudeColor().

## ◆ getStartFrequency()

double FrequencyDisplayPlot::getStartFrequency | ( |  | ) | const

Referenced by plotNewData().

## ◆ getStopFrequency()

double FrequencyDisplayPlot::getStopFrequency | ( |  | ) | const

References FrequencyDisplayPlot().

Referenced by plotNewData().

## ◆ getYMax()

double FrequencyDisplayPlot::getYMax | ( |  | ) | const

Referenced by getMaxFFTColor().

## ◆ getYMin()

double FrequencyDisplayPlot::getYMin | ( |  | ) | const

Referenced by getMinFFTColor().

## ◆ onPickerPointSelected

void FrequencyDisplayPlot::onPickerPointSelected | ( | const QPointF & | p | ) |
| slot

References setMarkerPeakAmplitudeColor(), and setMarkerUpperIntensityVisible().

Referenced by clearMaxData().

## ◆ plotNewData() [1/2]

void FrequencyDisplayPlot::plotNewData | ( | const double * | dataPoints,
|  | const int64_t | numDataPoints,
|  | const double | noiseFloorAmplitude,
|  | const double | peakFrequency,
|  | const double | peakAmplitude,
|  | const double | timeInterval )

References plotNewData().

## ◆ plotNewData() [2/2]

void FrequencyDisplayPlot::plotNewData | ( | const std::vector< const double * > | dataPoints,
|  | const int64_t | numDataPoints,
|  | const double | noiseFloorAmplitude,
|  | const double | peakFrequency,
|  | const double | peakAmplitude,
|  | const double | timeInterval )

References FrequencyDisplayPlot(), getStartFrequency(), getStopFrequency(), and setFrequencyRange().

Referenced by plotNewData(), and setYaxis().

## ◆ replot()

void FrequencyDisplayPlot::replot | ( |  | ) |
| overridevirtual

Implements DisplayPlot.

Referenced by showCFMarker().

## ◆ setAutoScale

void FrequencyDisplayPlot::setAutoScale | ( | bool | state | ) |
| slot

References setMarkerNoiseFloorAmplitudeVisible().

Referenced by clearMinData().

## ◆ setAutoScaleShot

void FrequencyDisplayPlot::setAutoScaleShot | ( |  | ) |
| slot

References setMarkerCFColor(), and setMarkerNoiseFloorAmplitudeColor().

Referenced by attachTriggerLine().

## ◆ setBGColour()

void FrequencyDisplayPlot::setBGColour | ( | QColor | c | ) |

Referenced by getMarkerUpperIntensityColor().

## ◆ setFrequencyRange()

void FrequencyDisplayPlot::setFrequencyRange | ( | const double | ,
|  | const double | ,
|  | const double | units = 1000.0,
|  | const std::string & | strunits = "kHz" )

References getMarkerCFColor(), getMarkerNoiseFloorAmplitudeVisible(), marker_CF_color, marker_noise_floor_amplitude_visible, setMarkerCFColor(), and setMarkerNoiseFloorAmplitudeVisible().

Referenced by plotNewData().

## ◆ setLowerIntensityLevel

void FrequencyDisplayPlot::setLowerIntensityLevel | ( | const double |  | ) |
| slot

References setMarkerLowerIntensityColor().

Referenced by setPlotPosHalf().

## ◆ setMarkerCFColor

void FrequencyDisplayPlot::setMarkerCFColor | ( | QColor | c | ) |
| slot

References setMaxFFTColor(), and setMinFFTColor().

Referenced by setAutoScaleShot(), and setFrequencyRange().

## ◆ setMarkerLowerIntensityColor

void FrequencyDisplayPlot::setMarkerLowerIntensityColor | ( | QColor | c | ) |
| slot

References getMarkerNoiseFloorAmplitudeVisible().

Referenced by setLowerIntensityLevel().

## ◆ setMarkerLowerIntensityVisible

void FrequencyDisplayPlot::setMarkerLowerIntensityVisible | ( | bool | visible | ) |
| slot

References getMarkerNoiseFloorAmplitudeColor().

Referenced by setUpperIntensityLevel().

## ◆ setMarkerNoiseFloorAmplitudeColor

void FrequencyDisplayPlot::setMarkerNoiseFloorAmplitudeColor | ( | QColor | c | ) |
| slot

References setMinFFTVisible().

Referenced by setAutoScaleShot(), and ~FrequencyDisplayPlot().

## ◆ setMarkerNoiseFloorAmplitudeVisible

void FrequencyDisplayPlot::setMarkerNoiseFloorAmplitudeVisible | ( | bool | visible | ) |
| slot

References setMaxFFTVisible().

Referenced by setAutoScale(), and setFrequencyRange().

## ◆ setMarkerPeakAmplitudeColor

void FrequencyDisplayPlot::setMarkerPeakAmplitudeColor | ( | QColor | c | ) |
| slot

Referenced by onPickerPointSelected().

## ◆ setMarkerUpperIntensityColor

void FrequencyDisplayPlot::setMarkerUpperIntensityColor | ( | QColor | c | ) |
| slot

References getMarkerCFColor().

Referenced by setUpperIntensityLevel().

## ◆ setMarkerUpperIntensityVisible

void FrequencyDisplayPlot::setMarkerUpperIntensityVisible | ( | bool | visible | ) |
| slot

Referenced by onPickerPointSelected().

## ◆ setMaxFFTColor

void FrequencyDisplayPlot::setMaxFFTColor | ( | QColor | c | ) |
| slot

References getMarkerPeakAmplitudeColor().

Referenced by setMarkerCFColor().

## ◆ setMaxFFTVisible

void FrequencyDisplayPlot::setMaxFFTVisible | ( | const bool |  | ) |
| slot

References getMarkerLowerIntensityVisible().

Referenced by setMarkerNoiseFloorAmplitudeVisible().

## ◆ setMinFFTColor

void FrequencyDisplayPlot::setMinFFTColor | ( | QColor | c | ) |
| slot

References getMarkerUpperIntensityVisible().

Referenced by setMarkerCFColor().

## ◆ setMinFFTVisible

void FrequencyDisplayPlot::setMinFFTVisible | ( | const bool |  | ) |
| slot

References getMarkerUpperIntensityColor().

Referenced by setMarkerNoiseFloorAmplitudeColor().

## ◆ setPlotPosHalf

void FrequencyDisplayPlot::setPlotPosHalf | ( | bool | half | ) |
| slot

References setLowerIntensityLevel().

Referenced by setTriggerLine().

## ◆ setTraceColour()

void FrequencyDisplayPlot::setTraceColour | ( | QColor |  | ) |

Referenced by getMarkerLowerIntensityVisible().

## ◆ setTriggerLine

void FrequencyDisplayPlot::setTriggerLine | ( | double | value | ) |
| slot

References attachTriggerLine(), clearMaxData(), clearMinData(), setPlotPosHalf(), setTriggerLine(), and setYLabel().

Referenced by setTriggerLine().

## ◆ setUpperIntensityLevel

void FrequencyDisplayPlot::setUpperIntensityLevel | ( | const double |  | ) |
| slot

References setMarkerLowerIntensityVisible(), and setMarkerUpperIntensityColor().

Referenced by setYLabel().

## ◆ setYaxis()

void FrequencyDisplayPlot::setYaxis | ( | double | min,
|  | double | max )
| overridevirtual

Reimplemented from DisplayPlot.

References plotNewData().

Referenced by getMinFFTVisible().

## ◆ setYLabel

void FrequencyDisplayPlot::setYLabel | ( | const std::string & | label,
|  | const std::string & | unit )
| slot

References setUpperIntensityLevel().

Referenced by setTriggerLine().

## ◆ showCFMarker()

void FrequencyDisplayPlot::showCFMarker | ( | const bool |  | ) |

References replot().

Referenced by getMarkerUpperIntensityVisible().

## Property Documentation

## ◆ marker_CF_color

QColor FrequencyDisplayPlot::marker_CF_color
| readwrite

Referenced by setFrequencyRange().

## ◆ marker_lower_intensity_color

QColor FrequencyDisplayPlot::marker_lower_intensity_color
| readwrite

## ◆ marker_lower_intensity_visible

bool FrequencyDisplayPlot::marker_lower_intensity_visible
| readwrite

## ◆ marker_noise_floor_amplitude_color

QColor FrequencyDisplayPlot::marker_noise_floor_amplitude_color
| readwrite

Referenced by ~FrequencyDisplayPlot().

## ◆ marker_noise_floor_amplitude_visible

bool FrequencyDisplayPlot::marker_noise_floor_amplitude_visible
| readwrite

Referenced by setFrequencyRange().

## ◆ marker_peak_amplitude_color

QColor FrequencyDisplayPlot::marker_peak_amplitude_color
| readwrite

## ◆ marker_upper_intensity_color

QColor FrequencyDisplayPlot::marker_upper_intensity_color
| readwrite

## ◆ marker_upper_intensity_visible

bool FrequencyDisplayPlot::marker_upper_intensity_visible
| readwrite

## ◆ max_fft_color

QColor FrequencyDisplayPlot::max_fft_color
| readwrite

## ◆ max_fft_visible

bool FrequencyDisplayPlot::max_fft_visible
| readwrite

## ◆ min_fft_color

QColor FrequencyDisplayPlot::min_fft_color
| readwrite

## ◆ min_fft_visible

bool FrequencyDisplayPlot::min_fft_visible
| readwrite

The documentation for this class was generated from the following file:

- FrequencyDisplayPlot.h